// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from naoqi_bridge_msgs:msg/RobotInfo.idl
// generated code does not contain a copyright notice

#ifndef NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_
#define NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NAO'.
enum
{
  naoqi_bridge_msgs__msg__RobotInfo__NAO = 0
};

/// Constant 'ROMEO'.
enum
{
  naoqi_bridge_msgs__msg__RobotInfo__ROMEO = 1
};

/// Constant 'PEPPER'.
enum
{
  naoqi_bridge_msgs__msg__RobotInfo__PEPPER = 2
};

// Include directives for member types
// Member 'model'
// Member 'head_version'
// Member 'body_version'
// Member 'arm_version'
#include "rosidl_runtime_c/string.h"

// Struct defined in msg/RobotInfo in the package naoqi_bridge_msgs.
typedef struct naoqi_bridge_msgs__msg__RobotInfo
{
  uint8_t type;
  rosidl_runtime_c__String model;
  rosidl_runtime_c__String head_version;
  rosidl_runtime_c__String body_version;
  rosidl_runtime_c__String arm_version;
  bool has_laser;
  bool has_extended_arms;
  int32_t number_of_legs;
  int32_t number_of_arms;
  int32_t number_of_hands;
} naoqi_bridge_msgs__msg__RobotInfo;

// Struct for a sequence of naoqi_bridge_msgs__msg__RobotInfo.
typedef struct naoqi_bridge_msgs__msg__RobotInfo__Sequence
{
  naoqi_bridge_msgs__msg__RobotInfo * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} naoqi_bridge_msgs__msg__RobotInfo__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // NAOQI_BRIDGE_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_H_
