// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from naoqi_bridge_msgs:msg/WordRecognized.idl
// generated code does not contain a copyright notice

#ifndef NAOQI_BRIDGE_MSGS__MSG__DETAIL__WORD_RECOGNIZED__STRUCT_HPP_
#define NAOQI_BRIDGE_MSGS__MSG__DETAIL__WORD_RECOGNIZED__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__naoqi_bridge_msgs__msg__WordRecognized __attribute__((deprecated))
#else
# define DEPRECATED__naoqi_bridge_msgs__msg__WordRecognized __declspec(deprecated)
#endif

namespace naoqi_bridge_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct WordRecognized_
{
  using Type = WordRecognized_<ContainerAllocator>;

  explicit WordRecognized_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit WordRecognized_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _words_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _words_type words;
  using _confidence_values_type =
    std::vector<float, typename ContainerAllocator::template rebind<float>::other>;
  _confidence_values_type confidence_values;

  // setters for named parameter idiom
  Type & set__words(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->words = _arg;
    return *this;
  }
  Type & set__confidence_values(
    const std::vector<float, typename ContainerAllocator::template rebind<float>::other> & _arg)
  {
    this->confidence_values = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> *;
  using ConstRawPtr =
    const naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__naoqi_bridge_msgs__msg__WordRecognized
    std::shared_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__naoqi_bridge_msgs__msg__WordRecognized
    std::shared_ptr<naoqi_bridge_msgs::msg::WordRecognized_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const WordRecognized_ & other) const
  {
    if (this->words != other.words) {
      return false;
    }
    if (this->confidence_values != other.confidence_values) {
      return false;
    }
    return true;
  }
  bool operator!=(const WordRecognized_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct WordRecognized_

// alias to use template instance with default allocator
using WordRecognized =
  naoqi_bridge_msgs::msg::WordRecognized_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace naoqi_bridge_msgs

#endif  // NAOQI_BRIDGE_MSGS__MSG__DETAIL__WORD_RECOGNIZED__STRUCT_HPP_
